<script setup lang="ts">
import { SVG, Svg } from '@svgdotjs/svg.js'
import { onMounted, ref, watch, reactive } from 'vue';
import { Line } from '@/lib/Line';
import { Tree } from '@/lib/Tree';
import presets from '@/components/presets.js';

const svg = ref<HTMLElement>()

let tree: Tree
let draw: Svg

const maxEdgeCount = ref(3000)
const speed = ref(0.2)
const edgeLength = ref(20)
const minAngle = ref(90)
const maxAngle = ref(90)
const minFanout = ref(2)
const maxFanout = ref(2)
const allowOverlap = ref(false)
const loop = ref(false)
const seedCount = ref(1)
const randomSeedPosition = ref(false)
const gravity = ref(false)
const hasMouseControl = ref(false)
const hasMouseBudGeneration = ref(false)
const mouseEffectRange = ref(50)
const selectedPreset = ref('')

const allRefs = reactive({
  maxEdgeCount,
  speed,
  edgeLength,
  minAngle,
  maxAngle,
  minFanout,
  maxFanout,
  allowOverlap,
  loop,
  seedCount,
  randomSeedPosition,
  gravity,
  hasMouseControl,
  hasMouseBudGeneration,
  mouseEffectRange,
  selectedPreset
})

function getOptions() {
  return {
    maxEdgeCount: maxEdgeCount.value,
    speed: speed.value,
    edgeLength: edgeLength.value,
    minAngle: minAngle.value,
    maxAngle: maxAngle.value,
    minFanout: minFanout.value,
    maxFanout: maxFanout.value,
    mouseEffectRange: mouseEffectRange.value,
    allowOverlap: allowOverlap.value,
    gravity: gravity.value,
    hasMouseControl: hasMouseControl.value,
    hasMouseBudGeneration: hasMouseBudGeneration.value
  }
}

function drawTree() {
  draw.clear()
  tree = new Tree(draw, getOptions())

  // report mounse position to tree object
  draw.on('mousemove', function (e) {
    var point = draw.node.createSVGPoint();

    point.x = (e as MouseEvent).clientX;
    point.y = (e as MouseEvent).clientY;

    if (draw.node.getScreenCTM() !== null) {
      var cursorPoint = point.matrixTransform(draw.node.getScreenCTM()!.inverse());
      tree.setMousePosition({ x: cursorPoint.x, y: cursorPoint.y })
    }
  });

  const windowWidth = window.innerWidth
  const windowHeight = window.innerHeight
  const numSeed = seedCount.value

  for (let i = 1; i <= numSeed; i++) {

    let getLine
    if (randomSeedPosition.value) {
      // position the the seed randomly
      getLine = (_: number) => {
        const getPoint = () => ({
          x: Math.random() * windowWidth / 2 + windowWidth / 4,
          y: Math.random() * windowHeight / 2 + windowHeight / 4
        })
        return (new Line(getPoint(), getPoint()))
      }

    } else {
      // position the the seed in a deterministic way
      getLine = (i: number) => new Line({
        x: windowWidth * 0.75 / (numSeed + 1) * (i) + windowWidth / 8,
        y: windowHeight * 0.75
      }, {
        x: windowWidth * 0.75 / (numSeed + 1) * (i) + windowWidth / 8,
        y: windowHeight * 0.75 - 10
      })
    }

    tree.addEdge({
      id: 0,
      line: getLine(i).toLength(edgeLength.value),
      completion: 0,
      svgLine: null,
      generation: 1,
      done: false
    })

  }

  const growInterval = window.setInterval(() => {
    tree.grow()
    tree.drawEdges()

    if (tree.isDone()) {
      window.clearInterval(growInterval)
      if (loop.value) {
        drawTree()
      }
    }
  }, 2)
}

function dumpSettings() {
  console.log(getOptions())
}

let animationPos: number
function animate() {

  window.setInterval(() => {
    animationPos += 10
    tree.animate(animationPos)
  }, 100)
}

onMounted(() => {
  draw = SVG().addTo(svg.value!).size('100%', '100%')
})

const presetsList = ref(presets.map(p => p.name))

// Watch for changes in the preset dropdown
watch(selectedPreset, (newVal) => {
  const preset = presets.find(p => p.name === newVal)
  if (preset) {
    Object.entries(preset.values).forEach(([key, value]) => {
      // @ts-ignore
      allRefs[key] = value
    })
  }
})

</script>

<template>
  <div class="flex flex-column w-full">
    <Panel class="z-5 absolute max-w-screen" toggleable header="Programmatic Tree Generator">
      <div class="hidden md:flex flex-row my-2 text-500 md:hidden">
        Choose a preset or change the parameters below.
        Hover over the labels to get more information.</div>
      <div class="flex md:hidden flex-row my-2 text-500 md:hidden">
        Choose a preset. Open it on a desktop for many more options.</div>
      <div class="hidden md:flex flex-row flex-wrap ">
        <div class="field m-2">
          <label for="lastname1" class="w-full text-center" v-tooltip="'How many lines to draw'">Max Edge Count</label>
          <Knob v-model="maxEdgeCount" :min="0" :max="20000" />
        </div>
        <div class="field m-2">
          <label for="lastname1" class="w-full text-center" v-tooltip="'How fast the graph should grow'">Speed</label>
          <Knob v-model="speed" :min="0" :max="0.5" :step="0.01" />
        </div>
        <div class="field m-2">
          <label for="lastname1" class="w-full text-center" v-tooltip="'The length of each line'">Edge Length</label>
          <Knob v-model="edgeLength" :min="1" :max="100" />
        </div>

        <div class="field m-2">
          <label for="lastname1" class="w-full text-center"
            v-tooltip="'The lower threshold of the angle between the lines'">Min. Angle</label>
          <Knob v-model="minAngle" :min="1" :max="180" />
        </div>

        <div class="field m-2">
          <label for="lastname1" class="w-full text-center"
            v-tooltip="'The upper threshold of the angle between the lines'">Max. Angle</label>
          <Knob v-model="maxAngle" :min="1" :max="180" />
        </div>

        <div class="field m-2">
          <label for="lastname1" class="w-full text-center"
            v-tooltip="'The lower threshold the amount of lines sprucing from a bud'">Min. Fanout</label>
          <Knob v-model="minFanout" :min="1" :max="5" />
        </div>

        <div class="field m-2">
          <label for="lastname1" class="w-full text-center"
            v-tooltip="'The upper threshold the amount of lines sprucing from a bud'">Max. Fanout</label>
          <Knob v-model="maxFanout" :min="1" :max="5" />
        </div>

        <div class="field m-2">
          <label for="lastname1" class="w-full text-center"
            v-tooltip="'The number of seeds that are planted at the beginning'">Seed Count</label>
          <Knob v-model="seedCount" :min="1" :max="20" />
        </div>

        <div class="field m-2">
          <label for="lastname1" class="w-full text-center"
            v-tooltip="'When using the mouse-induced-growth, how far the effect of the mouse reaches'">Mouse
            Range</label>
          <Knob v-model="mouseEffectRange" :min="1" :max="500" />
        </div>

      </div>
      <div class="field">
        <div class="hidden md:flex align-items-center sm:hidden">
          <Checkbox v-model="allowOverlap" class="m-2" inputId="allowOverlap" name="allowOverlap" :binary="true" />
          <label for="allowOverlap" class="m-2" v-tooltip="'The generated lines are allowed to overlap'"> allow overlap
          </label>
          <Checkbox v-model="loop" class="m-2" inputId="loop" name="loop" :binary="true" />
          <label for="loop" class="m-2" v-tooltip="'The generation should be restarted once it\'s completed'"> Loop
          </label>
          <Checkbox v-model="randomSeedPosition" class="m-2" inputId="randomSeedPos" name="randomSeedPos"
            :binary="true" />
          <label for="randomSeedPos" class="m-2" v-tooltip="'The seeds should be planted at random position'"> Random Seed
            Position </label>
          <Checkbox v-model="gravity" class="m-2" inputId="gravity" name="gravity" :binary="true" />
          <label for="gravity" class="m-2" v-tooltip="'The lines are only allowed to go upwards'"> Gravity </label>
          <Checkbox v-model="hasMouseControl" class="m-2" inputId="hasMouseControl" name="hasMouseControl"
            :binary="true" />
          <label for="hasMouseControl" class="m-2" v-tooltip="'Move your mouse to trigger the growth'"> Mouse induced
            Growth </label>
          <!--<Checkbox v-model="hasMouseBudGeneration" class="m-2" inputId="hasMouseBudGeneration"
            name="hasMouseBudGeneration" :binary="true" />
          <label for="hasMouseBudGeneration" class="m-2"> Mouse Bud Generation </label>-->
        </div>
      </div>
      <div class="field flex justify-content-between">

        <div><label class="hidden md:inline-block">Preset Selection</label>
          <Dropdown v-model="selectedPreset" :options="presetsList" placeholder="Select a Preset" class="md:mx-2" />
        </div>
        <Button label="Draw" class="mx-2" @click="drawTree()" />

      </div>
    </Panel>
    <div ref="svg" id="svgCanvas" style="width: 100vw; height: 100vh; position: absolute; top: 0; left: 0;"></div>
  </div>
</template>